%if %mdkversion == 300
%define build_for_corp3 1
%else
%define build_for_corp3 0
%endif

%if %build_for_corp3
%define distversion C30
%{?!mkrel:%define mkrel(c:) %{-c: 0.%{-c*}.}%{!?_with_unstable:%(perl -e '$_="%{1}";m/(.\*\\D\+)?(\\d+)$/;$rel=${2}-1;re;print "$1$rel";').%{?subrel:%subrel}%{!?subrel:1}.%{?distversion:%distversion}%{?!distversion:%(echo $[%{mdkversion}/10])}}%{?_with_unstable:%{1}}%{?distsuffix:%distsuffix}%{?!distsuffix:mdk}}
%endif

%if %mdkversion < 200700
%define subrel 2
%endif

%define firefox_package mozilla-firefox

%define name    mozilla-firefox-l10n
%define oname   mozilla-firefox
%define version 2.0.0.3
%define release %mkrel 1
%define firefox_version %{version}
%if %mdkversion <= 200700
%define mozillalibdir %{_libdir}/mozilla-firefox-%{firefox_version}
%else
%define mozillalibdir %{_libdir}/firefox-%{firefox_version}
%endif
%define xpidir http://ftp.mozilla.org/pub/mozilla.org/firefox/releases/%{firefox_version}/linux-i686/xpi/

# Supported l10n language lists
%define l10n_langlist	ar bg br ca cs da de el es es_AR eu fi fr fy ga gu_IN he hu it ja ko lt mk nb nn nl pa_IN pl pt pt_BR ro ru sk sl sv tr uk zh_CN zh_TW

# Disabled l10n languages, for any reason
%define disabled_l10n_langlist	br he ro uk pa_IN

# Supported language dicts
%define dict_langlist	bg ca cs de fr pt_BR nl

%define disabled_dict_langlist	""

%define dict_src_bg http://releases.mozilla.org/pub/mozilla.org/extensions/bulgarian_dictionary/bulgarian_dictionary-2.0.0.1-fx+zm+tb.xpi
%define dict_src_ca http://releases.mozilla.org/pub/mozilla.org/extensions/diccionari_catal_agrave_/diccionari_catal_agrave_-0.1-fx+zm+tb.xpi
%define dict_src_cs http://releases.mozilla.org/pub/mozilla.org/extensions/czech_spell_checking_dictionary/czech_spell_checking_dictionary-1.0-fx+zm+tb.xpi
%define dict_src_de http://releases.mozilla.org/pub/mozilla.org/extensions/deutsches_w_ouml_rterbuch/deutsches_w_ouml_rterbuch-1.0.1-fx+zm+tb.xpi
%define dict_src_fr http://releases.mozilla.org/pub/mozilla.org/extensions/dictionnaire_myspell_en_fran_ccedil_ais_r_eacute_forme_1990_/dictionnaire_myspell_en_fran_ccedil_ais_r_eacute_forme_1990_-1.0-fx.xpi
%define dict_src_pt_BR http://releases.mozilla.org/pub/mozilla.org/extensions/pt-br_spelling_dictionary/pt-br_spelling_dictionary-1.0-fx+tb.xpi
%define dict_src_nl https://www.uitwisselplatform.nl/frs/download.php/278/nl_NL_110307_pack-fx+tb.xpi

# Language descriptions
%define language_ar ar
%define langname_ar Arabic
%define language_bg bg
%define langname_bg Bulgarian
%define langname_br Breton
%define language_br br-FR
%define language_ca ca
%define langname_ca Catalan
%define language_cs cs
%define langname_cs Czech
%define language_da da
%define langname_da Dansk
%define language_de de
%define langname_de German
%define language_el el
%define langname_el Greek
%define language_es_AR es-AR
%define langname_es_AR Spanish (Argentina)
%define language_es es-ES
%define langname_es Spanish
%define langname_eu Basque
%define language_eu eu
%define language_fi fi
%define langname_fi Finnish
%define language_fr fr
%define langname_fr French
%define langname_fy Frisian
%define language_fy fy-NL
%define language_ga ga-IE
%define langname_ga Irish
%define language_gu_IN gu-IN
%define langname_gu_IN Gujarati
%define language_he he
%define langname_he Hebrew
%define language_hu hu
%define langname_hu Hungarian
%define language_it it
%define langname_it Italian
%define language_ja ja
%define langname_ja Japanese
%define language_ko ko
%define langname_ko Korean
%define langname_lt Lithuanian
%define language_lt lt
%define langname_mk Macedonian
%define language_mk mk
%define language_nb nb-NO
%define langname_nb Norwegian Bokmaal
%define language_nn nn-NO
%define langname_nn Norwegian Nynorsk
%define langname_nl Dutch
%define language_nl nl
%define language_pa_IN pa-IN
%define langname_pa_IN Punjabi (gurmukhi)
%define language_pl pl
%define langname_pl Polish
%define langname_pt_BR Brazilian portuguese
%define language_pt_BR pt-BR
%define langname_pt Portuguese
%define language_pt pt-PT
%define language_ro ro
%define langname_ro Romanian
%define language_ru ru
%define langname_ru Russian
%define language_sk sk
%define langname_sk Slovak
%define language_sl sl
%define langname_sl Slovenian
%define language_sv sv-SE
%define langname_sv Swedish
%define language_tr tr
%define langname_tr Turkish
%define langname_uk Ukrainian
%define language_uk uk-UA
%define langname_zh_CN Simplified Chinese
%define language_zh_CN zh-CN
%define langname_zh_TW Traditional Chinese
%define language_zh_TW zh-TW

# --- Danger line ---

# All langs
%{expand:%%define langlist %(for lang in %l10n_langlist %dict_langlist; do echo "$lang"; done | sort -u | sed ':a;$!N;s/\n/ /;ta')}

# Defaults (all languages enabled by default)
# l10n
%{expand:%(for lang in %dict_langlist; do echo "%%define l10n_$lang 0"; done)}
%{expand:%(for lang in %l10n_langlist; do echo "%%define l10n_$lang 1"; done)}
%{expand:%(for lang in %disabled_l10n_langlist; do echo "%%define l10n_$lang 0"; done)}
# dicts
%{expand:%(for lang in %l10n_langlist; do echo "%%define dict_$lang 0"; done)}
%{expand:%(for lang in %dict_langlist; do echo "%%define dict_$lang 1"; done)}
%{expand:%(for lang in %disabled_dict_langlist; do echo "%%define dict_$lang 0"; done)}

# Params
%{expand:%(for lang in %langlist; do echo "%%bcond_without $lang"; done)}

# Locales
%{expand:%(for lang in %l10n_langlist; do echo "%%define locale_$lang `echo $lang | cut -d _ -f 1` "; done)}

# Macro for easy adding i18n sources
# auto-increment as called.
%define src 1

%define l10nsrc() Source%src: %{xpidir}/%{1}.xpi\
%define src2 %(echo $((%src+1)))\
%define src %{src2}

%define dictsrc() Source%src: %{1}\
%define src2 %(echo $((%src+1)))\
%define src %{src2}

Summary: Localizations for Firefox (virtual package)
Name: %{name}
Version: %{version}
Release: %{release}
License: GPL
Group: Networking/WWW
Url: http://www.mozilla.org/
# Language package template
Source0: %{name}-template.spec
# l10n sources
%{expand:%(\
	for lang in %l10n_langlist; do\
		echo "%%{expand:%%l10nsrc %%{language_$lang}}";\
	done\
	)
}
# Dict sources
%{expand:%(\
	for lang in %dict_langlist; do\
		echo "%%{expand:%%dictsrc %%{dict_src_$lang}}";\
	done\
	)
}
Patch4: pt-PT-xml-validation.patch
Patch5: fy-NL-xml-validation.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: libxml2-utils

%description
Localizations for Firefox

# Expand all languages packages.
%{expand:%(\
	for lang in %langlist; do\
		echo "%%{expand:%%(sed "s!__LANG__!$lang!g" %{_sourcedir}/%{name}-template.spec 2> /dev/null)}";\
	done\
	)
}

%prep
%setup -q -c -T

# Convert rpm macros to bash variables
%{expand:%(for lang in %langlist; do echo "language_$lang=%%{language_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "with_$lang=%%{with $lang}"; done)}
%{expand:%(for lang in %l10n_langlist; do echo "l10n_$lang=%%{l10n_$lang}"; done)}
%{expand:%(for lang in %dict_langlist; do echo "dict_$lang=%%{dict_$lang}"; done)}
%{expand:%(for lang in %dict_langlist; do echo "dict_src_$lang=%%{dict_src_$lang}"; done)}

# Unpack all languages
for lang in %l10n_langlist; do
	with="with_$lang"
	with=${!with}
	[ $with -eq 0 ] && continue

	l10n="l10n_$lang"
	l10n=${!l10n}
	[ $l10n -eq 0 ] && continue

	language="language_$lang"
	language=${!language}
	mkdir ${language}
	cd ${language}
	unzip %{_sourcedir}/${language}.xpi
	cd ..
done

# Unpack all dicts
for lang in %dict_langlist; do
	with="with_$lang"
	with=${!with}
	[ $with -eq 0 ] && continue

	dict="dict_$lang"
	dict=${!dict}
	[ $dict -eq 0 ] && continue

	src="dict_src_$lang"
	src=$(basename ${!src})
	[ $dict -eq 0 ] && continue

	language="language_$lang"
	language=${!language}
	mkdir ${language}-dict
	cd ${language}-dict
	unzip %{_sourcedir}/${src}
	cd ..
done

# Disable version check
sed -i -e 's/maxVersion>.*</maxVersion>2.0.*</g' */install.rdf

# Patches
cd ${language_pt}
%patch4 -p0
cd ..
cd ${language_fy}
%patch5 -p8
cd ..

%build
# All install.rdf files must validate
xmllint --noout */install.rdf

%install
rm -rf %buildroot

# Convert rpm macros to bash variables
%{expand:%(for lang in %langlist; do echo "language_$lang=%%{language_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "with_$lang=%%{with $lang}"; done)}
%{expand:%(for lang in %l10n_langlist; do echo "l10n_$lang=%%{l10n_$lang}"; done)}
%{expand:%(for lang in %dict_langlist; do echo "dict_$lang=%%{dict_$lang}"; done)}

# Install all languages
for lang in %langlist; do
	with="with_$lang"
	with=${!with}
	[ $with -eq 0 ] && continue

	l10n="l10n_$lang"
	l10n=${!l10n}
	[ $l10n -eq 0 ] && continue

	language="language_$lang"
	language=${!language}
	cd $language
	mkdir -p %buildroot%{mozillalibdir}/extensions/langpack-${language}@firefox.mozilla.org/
	cp -f -r * %buildroot%{mozillalibdir}/extensions/langpack-${language}@firefox.mozilla.org/
	cd ..
done

# Install all dicts
mkdir -p %buildroot%{mozillalibdir}/dictionaries
for lang in %langlist; do
	with="with_$lang"
	with=${!with}
	[ $with -eq 0 ] && continue

	dict="dict_$lang"
	dict=${!dict}
	[ $dict -eq 0 ] && continue

	language="language_$lang"
	language=${!language}
	cp -vf $language-dict/dictionaries/*.{aff,dic} \
		%buildroot%{mozillalibdir}/dictionaries |\
		sed "s/.* \`\(.*\)'/\1/;s@.*/usr@/usr@" > %{_builddir}/%{name}-%{version}/$lang.dict
done

%clean
rm -rf %buildroot


%changelog
* Thu Mar 22 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.3-1mdv2007.1
+ Revision: 147906
- Synced with firefox version. 2.0.0.3

* Tue Mar 20 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.2-3mdv2007.1
+ Revision: 146985
- Added Dutch spell check dictionary based on Reinout van Schouwen changes. Closes: #29651

* Wed Feb 28 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.2-2mdv2007.1
+ Revision: 127264
- Do not require libmozilla-firefox, but mozilla-firefox instead.
  Closes: #28967

* Wed Feb 28 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.2-1mdv2007.1
+ Revision: 127082
- New version: 2.0.0.2
  Synced with FF version.

* Wed Jan 10 2007 Nicolas Lécureuil <neoclust@mandriva.org> 2.0.0.1-2mdv2007.1
+ Revision: 106953
- Fix translations on mdv <= 2007.0

* Fri Dec 29 2006 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0-5mdv2007.1
+ Revision: 102552
- Sync with FF version. (2.0.0.1)
- Improve dict handling so we keep tracking their sources/versions.
- Added fr de and cs dictionaries
- Do not force pkg langname with dictionaries filenames.
- Added support for dictionaries.
- Make use of bcond_without macro instead hacking ourselves.

* Sat Dec 09 2006 Eskild Hustvedt <eskild@mandriva.org> 2.0-4mdv2007.1
+ Revision: 94359
- Added Norwegian Nynorsk translation

* Fri Dec 08 2006 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0-3mdv2007.1
+ Revision: 93622
- Fix bg_BG and eu_ES langpack filenames according to their .xpi contents.
- Make locales list dynamic.

  + Frederic Crozat <fcrozat@mandriva.com>
    - Add missing locale requires

* Fri Dec 08 2006 Nicolas Lécureuil <neoclust@mandriva.org> 2.0-2mdv2007.1
+ Revision: 92160
- Fix missing locale macro (ticket #27535)

* Tue Dec 05 2006 Frederic Crozat <fcrozat@mandriva.com> 2.0-1mdv2007.1
+ Revision: 91264
- Fix incorrect description for zh-TW (Mdv bug #27464)

  + Marcelo Ricardo Leitner <mrl@mandriva.com>
    - Sorted things out.
    - All languages should follow the same struct. So, treat them
      all as just 'one more language' to the system.
    - Better use of %%prep, %%build and %%install sections.
    - Unpack and install all languages at once.
    - Added back supported languages but yet disabled.

  + Nicolas Lécureuil <neoclust@mandriva.org>
    - Add new xpi files
    - New version 2.0

* Wed Nov 08 2006 Frederic Crozat <fcrozat@mandriva.com> 1.5.0.8-1mdv2007.0
+ Revision: 78311
-Sync before commit to svn
- Update langpack to version 1.5.0.8
- new langpack for Gujarati
- Remove patch1 (no longer needed)

* Fri Sep 15 2006 Frederic Crozat <fcrozat@mandriva.com> 1.5.0.7-1mdv2007.0
+ Revision: 61619
- Add more languages
- Release 1.5.0.7
- Fix dependencies

* Wed Sep 06 2006 Frederic Crozat <fcrozat@mandriva.com> 1.5.0.6-2mdv2007.0
+ Revision: 60321
- subrel is only for 2006

* Wed Sep 06 2006 Frederic Crozat <fcrozat@mandriva.com> 1.5.0.6-2mdv2007.0.2
+ Revision: 60294
- Fix korean install.rdf to validate
- redo breton zip file
- fix various translations pack
- clean specfile
- remove version check in each install.rdf file
- validate install.rdf files at compile time

  + Nicolas Lécureuil <neoclust@mandriva.org>
    - add macros for corpo3
    - Use old name for packages (avoid provides/obsoletes) thanks fcrozat
    - Another bunch of fixes
    - Fix some languages ( es, pt-BR, ga, nb) thanks chty (QA)
    - mozilla-firefox-l10n-1.5.0.6-2mdv2007.0
    - Add Provides/Obsoletes
    - Fix Sources
    - import mozilla-firefox-l10n-1.5.0.6-1mdv2007.0


